clear;    %clear all variables in memory

%----------------INPUT PARAMETERS: ----------------------
fid = fopen('Parameters.txt','r');  %input file  *.in  with the initial LITE parameters, only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i == 1
        BBB = strread(row, '%s', 'delimiter', ' ');
        Star = cellstr([BBB(1)]);
%         Star = cellstr([BBB(1) BBB(2) BBB(3) BBB(4) BBB(5) BBB(6) BBB(7) BBB(8) BBB(9) BBB(10)]); 
%         Star = cellstr(BBB);
        Star = Star';
    else
       if row ~= -1
         A=sscanf(row,'%f');
         Y(i-1)=A(1);
         Yy(i-1)=A(2);
         F(i-1)=A(3);
     end
    end
end
status = fclose('all');      %close the file
clear A row i fid status;    %it is better to clear all unnecessary variables from the memory
Y=Y';
Yy=Yy';
%------------------------------------------------------------

%---------------INPUT DATA POINTS (=astrometric measurements): ---------------------
fid = fopen('Astrometry_2.txt','r');  %input file  *.dat, open only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i ~= 1
       if row ~= -1
         A=sscanf(row,'%f');
         YearAstr(i-1)=A(1);  %astrometric measurement - year
         PosAng(i-1)=A(2);    %astrometric measurement - position angle
         SigmaPosAng(i-1)=A(3); %astrometric measurement - sigma of position angle
         Separ(i-1)=A(4);     %astrometric measurement - angular separation
         SigmaSepar(i-1)=A(5);  %astrometric measurement - sigma of angular separation
     end
    end
end
status = fclose('all');
clear A row fid status;
PocetAstr=i-2;   %pocet astrometrickych mereni 
%----------------------------------------------------------------

%---------------INPUT DATA POINTS (=minima times): ---------------------
fid = fopen('Epoch_times_2.txt','r');  %input file  *.min  with the data (times of minima - JDi and Epochs), open only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i ~= 1
       if row ~= -1
         A=sscanf(row,'%f');
         JDi(i-1)=A(1);      %Julian date of individual minima times
         SigmaMin(i-1)=A(2);   %Sigma of individual minima times
         Epo0(i-1)=A(3);     %Epochs of individual minimum times
         Weight(i-1)=A(4);
     end
    end
end
status = fclose('all');
clear A row fid status;
%----------------------------------------------------------------
N=i-2;      %number of data points (minima times)
param=10;     %number of parameters to fit (2 ephemeris, 5 LITE, 1 quadratic, 2 astrometric)
alfa=1.0;     %parameters of the simplex itself:
beta=0.35;
gama=2.0;
delta=0.5;

%XXXXXXXXXXXXXXXXX  I N P U T :  XXXXXXXXXXXXXXXXXXXXX
    M1=1.86;		%mass of the primary star
    M2=1.53;		%mass of the secondary star
    M12=M1+M2;
    MaxExc=0.84;

    paralax=15.53;  %parallax in mas (from Hipparcos)
    ErrPar=1.16;   % error of parallax
%XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

JDi=JDi';   %Minima times
Weight=Weight';   %Weights of individual minima times
SigmaMin=SigmaMin'; %Sigma of individual measurement
Epo0=Epo0';        %Epoch of individual minima times

JD00=Y(1);    %here are 10 parameters of the LITE + Astrometry from the Y matrix
P=Y(2);
p3=Y(3);
T0=Y(4);
A=Y(5);
omega3=Y(6);
excen3=Y(7);
qmt=Y(8);
i3=Y(9);
Omega3=Y(10);
clear Y;

deltaJD=Yy(1);
deltaP=Yy(2);
deltap3=Yy(3);
deltaT0=Yy(4);
deltaexcen3=Yy(7);
deltaA=Yy(5);
deltaomeg3=Yy(6);
deltaq=Yy(8);
deltaOmega3=Yy(10);
deltai3=Yy(9);
clear Yy;

JD00F=F(1);
PF=F(2);
p3F=F(3);
T0F=F(4);
AF=F(5);
omega3F=F(6);
excen3F=F(7);
qmtF=F(8);
i3F=F(9);
Omega3F=F(10);
clear F;

vzdalenostAU = 206265/sin(paralax/1000);  %vzdalenost v AU
a12=abs(173.14*A/(sin(i3*pi/180)*sqrt(1-excen3^2*(cos(omega3*pi/180))^2)));  %poloosa obehu 3.slozky v AU
fm3=1/(p3/365.24)^2*((173.14*A/sqrt(1-(excen3*cos(omega3*pi/180))^2 ))^3);   %mass function
m3def=SpoctiHmotnost(i3,M12,fm3);   %v hmotach Slunce
a3=a12*M12/m3def;
a =180/pi*60*60*asin((a12+a3)/vzdalenostAU);   %uhlova poloosa obehu v arcsec
clear m3def fm3 a3;

%-=-=-=-=- zde vykresleni krivky na obloze jeste pred vypoctem -=-=-=-=-=-
PocetAstrPouzitych=length(YearAstr);    %pocet opravdove pouzitych, s vahou > 0

xBody=(-1)*Separ.*sin(PosAng*pi/180);   %zde jsou souradnice bodu mereni
yBody=Separ.*cos(PosAng*pi/180);
% clear Separ PosAng;

for i = 1: PocetAstrPouzitych
    HJD(i)=YearToJul(YearAstr(i));
end

j=0;
for HJDKrivky = YearToJul(YearAstr(1)):(p3/2000):(YearToJul(YearAstr(1))+p3)     %pro vykresleni krivky pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJDKrivky,T0,p3,excen3,a,Omega3,omega3,i3);
    xKrivka(j) = Hodnota(1);     %zde souradnice bodu krivky
    yKrivka(j) = Hodnota(2);
    clear Hodnota;
end
clear HJDKrivky;

j=0;
for i = 1:PocetAstrPouzitych     %zde jen teoreticke body na krivce pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJD(i),T0,p3,excen3,a,Omega3,omega3,i3);
    xOdBodu(j) = Hodnota(1);     %zde souradnice bodu krivky
    yOdBodu(j) = Hodnota(2);
    clear Hodnota;
end

%-----------  figure 1  = before computation  ------------------>
figure(1);
plot(xBody,yBody,'.','MarkerSize',12);    %namerene body
hold on
plot(0,0,'kx','MarkerSize',12);          %stred obehu
plot(xOdBodu,yOdBodu,'r.','MarkerSize',7);  %body na teoreticke krivce
plot(xKrivka,yKrivka,'k.','MarkerSize',1);             % krivka samotna
for i = 1:PocetAstrPouzitych
    X=[xOdBodu(i),xBody(i)];
    Y=[yOdBodu(i),yBody(i)];
    line(X,Y);
    clear X Y;
end
xlabel('RA[arcsec]');
ylabel('DE[arcsec]');
% axis([-0.15 0.15 -0.15 0.15]);
set(gca,'PlotBoxAspectRatio',[1 1 1]);
hold off
clear xKrivka yKrivka xOdBodu yOdBodu;
%-------------------------------------------------------------------
%-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
%Epo0=Epoch(JDi,JD00,P);    %Epoch of individual minima times
O=JDi-JD00-P*Epo0;         %O-C difference

PocetPrim=0;
PocetSec=0;
for i = 1:N
   switch round(10*abs(Epo0(i)-round(Epo0(i))))
   case 0
       PocetPrim=PocetPrim+1;
       E11(PocetPrim)=Epo0(i);    %primary minima times
       Occ1(PocetPrim)=O(i);
       B1(PocetPrim)=Weight(i);
   case 5            %secondary minima times
       PocetSec=PocetSec+1;
       E21(PocetSec)=Epo0(i);
       Occ2(PocetSec)=O(i);   
       B2(PocetSec)=Weight(i);
   end
end

m=1;
n=1;
o=1;
o1=1;
remove=0;       %some minima times were eliminated
for i = 1:PocetPrim     %primary minima times
   switch B1(i)
   case 0          %weight = 0  =>  ignore this minimum!
      remove=remove+1;     %removed minima times (=weight 0)
   case 1        %visual primary minima times
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 2        %visual primary minima times
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 3        %visual primary minima times
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 4        %visual primary minima times
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 5       %photographic primary minima times, worse quality
      E1pp(o1)=E11(i);
      O1pp(o1)=Occ1(i);
      o1=o1+1;
   case 10        %photographic primary minima times
      E1p(o)=E11(i);
      O1p(o)=Occ1(i);
      o=o+1;
   case 30       %ccd primary minima times
      E1c(m)=E11(i);
      O1c(m)=Occ1(i);
      m=m+1;
   end
end

p=1;
q=1;
r=1;
o2=1;
for i = 1:PocetSec     %secondary minima times
   switch B2(i)
   case 0
      remove=remove+1;   %removed secondary minima times
   case 1         %visual secondary minima times
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 2         %visual secondary minima times
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 3         %visual secondary minima times
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 4         %visual secondary minima times
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 5       %photographic secondary minima times, worse quality
      E2pp(o2)=E21(i);
      O2pp(o2)=Occ2(i);
      o2=o2+1;
   case 10         %photographic secondary minima times
      E2p(q)=E21(i);
      O2p(q)=Occ2(i);
      q=q+1;
   case 30        %ccd secondary minima times
      E2c(r)=E21(i);
      O2c(r)=Occ2(i);
      r=r+1;
   end
end

minimumE=500*floor(min(Epo0)/500)-100;
maximumE=500*ceil(max(Epo0)/500)+200;

Ep=minimumE:(maximumE-minimumE)/200:maximumE;       %plot a curve
JDi0=Ep*P+JD00;
Oc=OminusC(JDi0,T0,A,p3,omega3,excen3) + 10^(-10)*qmt*Ep.*Ep;

%--------------- HERE PLOT THE FIGURE: --------------------
figure(2);
clf;
set(gca,'box','on');
hold on
if n > 1 plot(E1v,O1v,'k.','MarkerSize',6); end    %plot primary visual minima times
if o1 > 1 plot(E1pp,O1pp,'k.','MarkerSize',8); end  %primary photographic minima times, worse quality
if o > 1 plot(E1p,O1p,'k.','MarkerSize',12); end   %primary photographic minima times
if m > 1 plot(E1c,O1c,'k.','MarkerSize',17); end   %primary ccd minima times
if p > 1 plot(E2v,O2v,'ko','MarkerSize',2); end    %secondary visual minima times
if o2 > 1 plot(E2pp,O2pp,'ko','MarkerSize',2); end  %secondary photographic minima times, worse quality
if q > 1 plot(E2p,O2p,'ko','MarkerSize',3); end    %secondary photographic minima times
if r > 1 plot(E2c,O2c,'ko','MarkerSize',4); end    %secondary ccd minima times
plot(Ep,Oc,'r-');
xlabel('Epoch');   %labeling the axis
ylabel('O-C (Days)');
title('O-C diagram');   %labeling the figure
hold off
%--------------------------------------------------------------------------
clear E1c E1v E1p E2c E2v E2p E1pp E2pp O1pp O2pp O1v O1c O1p O2v O2c O2p j k m n o o1 p q r o2 B1 B2 Occ1 Occ2 E11 E21 O Oc Ep JDi0 minimumE maximumE;   %clear all unnecessary variables
%---------------------------------------------------------------------------------------------------------
CelkemBodu = N+PocetAstrPouzitych;
MaxOkoli=25;
for i = -MaxOkoli:0.1:MaxOkoli
    if (1-gammainc(CelkemBodu,CelkemBodu+i)) < 0.97     %hladina 95% 
        Bod = CelkemBodu+i;   %bod kde je 5% hladina a tedy v tomto okoli kolem globalniho minima hledam vsechna reseni!
    end
end
if abs(Bod - CelkemBodu) > MaxOkoli-1
    disp(['Something wrong!!']);
end

chisqr = SumaCtvercuLITE3(JDi,SigmaMin*sqrt(N),Epo0,JD00,P,T0,A,p3,omega3,excen3,qmt) + CelkemAstroSigma(PocetAstrPouzitych,SigmaPosAng*sqrt(PocetAstrPouzitych),SigmaSepar*sqrt(PocetAstrPouzitych),HJD,T0,p3,excen3,a,Omega3,omega3,i3,PosAng,Separ);
number = CelkemBodu / chisqr;
SigmaMin = SigmaMin*sqrt(N) / sqrt(number);
SigmaPosAng = SigmaPosAng*sqrt(PocetAstrPouzitych) / sqrt(number);
SigmaSepar = SigmaSepar*sqrt(PocetAstrPouzitych) / sqrt(number);
chisqr0 = SumaCtvercuLITE3(JDi,SigmaMin,Epo0,JD00,P,T0,A,p3,omega3,excen3,qmt) + CelkemAstroSigma(PocetAstrPouzitych,SigmaPosAng,SigmaSepar,HJD,T0,p3,excen3,a,Omega3,omega3,i3,PosAng,Separ);

degOfFree=param;
clear chisqr;

% ============  ZDE ZACINA CELY CYKLUS  ============
PocitadloVnejsi=0;
PocitadloProGraf=0;

quadr=input('Do you also want to use the quadratic term (mass transfer) \n besides the LITE (1) or only LITE (0), or only quadratic term (2) ?');
if quadr ~= 1
    if quadr ~= 0
        if quadr ~= 2
            disp(['']);
            disp('Somethig is wrong, continue with no quadratic term.');
            quadr=0;
            disp(['']);
        end
    end
end

count = input('How many steps in one calculation of the simplex algorithm? \n (a few, depends on the speed of the computer): ');
disp([' ']);
input('Now the numbers on the screen represent (decreasing) sum \nof the square residuals from all minima times \nin the best vertex of the actual simplex.');

contin = 1;
while contin == 1
    PocitadloVnejsi=PocitadloVnejsi+1;
    %---------------- HERE THE SIMPLEX ALGORITHM!!! ----------------->
    if JD00F == 1
        JD0D=JD00+random('Normal',0,0.0001,1,param+1);
        JD0D(1)=JD00;
    else
        JD0D=JD00+random('Normal',0,0.0,1,param+1);
        JD0D(1)=JD00;
    end
    
    if PF == 1
        PD=P+random('Normal',0,0.0000001,1,param+1);
        PD(1)=P;
    else
        PD=P+random('Normal',0,0.0,1,param+1);
        PD(1)=P;
    end
    
    if p3F == 1
        p3D=p3+random('Normal',0,1700,1,param+1);
        p3D(1)=p3;
    else
        p3D=p3+random('Normal',0,0,1,param+1);
        p3D(1)=p3;
    end
    
    if T0F == 1
        T0D=T0+random('Normal',0,1700,1,param+1);
        T0D(1)=T0;
    else
        T0D=T0+random('Normal',0,0,1,param+1);
        T0D(1)=T0;
    end
    
    if omega3F == 1
        omega3D=omega3+random('Normal',0,120.0,1,param+1);
        omega3D(1)=omega3;
    else
        omega3D=omega3+random('Normal',0,0.0,1,param+1);
        omega3D(1)=omega3;
    end
    
    if excen3F == 1
        excen3D=excen3+random('Normal',0,0.06,1,param+1);
        excen3D(1)=excen3;
        for i = 1:param+1
            if excen3D(i) >= MaxExc
                excen3D(i)=MaxExc;
            end
        end
    else
        excen3D=excen3+random('Normal',0,0.0,1,param+1);
        excen3D(1)=excen3;
    end
    
    for i = 1:param+1
       if p3D(i) <= 0
          p3D(i)=abs(p3D(i));
       end
    end 

    if quadr == 2        %the case when we want to use only the quadratic term
        AD=random('Normal',0,0.0,1,param+1);
        if qmtF == 1
            qD=qmt+random('Normal',0,0.075,1,param+1);
            qD(1)=qmt;
        else
            qD=qmt+random('Normal',0,0.0,1,param+1);
            qD(1)=qmt;
        end
    elseif quadr == 1    %the case when we want to use the quadratic term with the LITE together
        if AF == 1
            AD=A+random('Normal',0,0.085,1,param+1);
            AD(1)=A;
        else
            AD=A+random('Normal',0,0.0,1,param+1);
            AD(1)=A;
        end
        if qmtF == 1
            qD=qmt+random('Normal',0,0.27,1,param+1);
            qD(1)=qmt;
        else
            qD=qmt+random('Normal',0,0.0,1,param+1);
            qD(1)=qmt;
        end
    else                %the case when we want to compute only LITE
        qD=random('Normal',0,0.0,1,param+1);
        if AF == 1
            AD=A+random('Normal',0,0.07,1,param+1);
            AD(1)=A;
        else
            AD=A+random('Normal',0,0.0,1,param+1);
            AD(1)=A;
        end
    end

    if i3F == 1
        i3D=i3+random('Normal',0,120,1,param+1);
        i3D(1)=i3;
    else
        i3D=i3+random('Normal',0,0,1,param+1);
        i3D(1)=i3;
    end
    
    if Omega3F == 1
        Omega3D=Omega3+random('Normal',0,150,1,param+1);
        Omega3D(1)=Omega3;
    else
        Omega3D=Omega3+random('Normal',0,0,1,param+1);
        Omega3D(1)=Omega3;
    end
    
    konst=450;
    abacus=konst+1;
    fl=0.001;
    fl0=0;

    for i = 1:konst+1
        sumactvercu(i)=0;
    end
    sumactvercu(abacus)=1;
    PocetPod20tis=1;
  while (sumactvercu(abacus) ~= sumactvercu(abacus-konst)) & (PocetPod20tis)   %podminka zastaveni, kdyz se jiz suma ctvercu nemeni a pocet iteraci je < 20 000!
      if (abacus-konst) < 5000
          PocetPod20tis = 1;
      else
          PocetPod20tis = 0;
      end
    fl0=fl;
    abacus=abacus+1;

    %----------zde funkcni hodnoty od vsech mereni, ode vsech parametru --------
    for i=1:param+1
        a12(i) = abs(173.14*AD(i)/(sin(i3D(i)*pi/180)*sqrt(1-excen3D(i)^2*(cos(omega3D(i)*pi/180))^2)));
        fm3(i)=1/(p3D(i)/365.24)^2*((173.14*AD(i)/sqrt(1-(excen3D(i)*cos(omega3D(i)*pi/180))^2 ))^3);   %mass function
        a3(i)=abs(a12(i)*M12/(SpoctiHmotnost(i3D(i),M12,fm3(i))));
        aD(i) = 180/pi*60*60*asin((a12(i)+a3(i))/vzdalenostAU);   %uhlova poloosa obehu v arcsec
        SumaCtvercu(i) = SumaCtvercuLITE3(JDi,SigmaMin,Epo0,JD0D(i),PD(i),T0D(i),AD(i),p3D(i),omega3D(i),excen3D(i),qD(i)) + CelkemAstroSigma(PocetAstrPouzitych,SigmaPosAng,SigmaSepar,HJD,T0D(i),p3D(i),excen3D(i),aD(i),Omega3D(i),omega3D(i),i3D(i),PosAng,Separ);
        
        chisqr(i) = SumaCtvercu(i);
        if abs(chisqr(i) - chisqr0) < abs(Bod-chisqr0)+1 %degOfFree
            if abs(JD0D(i)-JD00) > deltaJD
                deltaJD = abs(JD0D(i)-JD00);
            end
            if abs(PD(i)-P) > deltaP
                deltaP = abs(PD(i)-P);
            end
            if abs(p3D(i)-p3) > deltap3
                deltap3 = abs(p3D(i)-p3);
            end
            if abs(T0D(i)-T0) > deltaT0
                deltaT0 = abs(T0D(i)-T0);
            end
            if abs(excen3D(i)-excen3) > deltaexcen3
                deltaexcen3 = abs(excen3D(i)-excen3);
            end
            if abs(AD(i)-A) > deltaA
                deltaA = abs(AD(i)-A);
            end
            if abs(omega3D(i)-omega3) > deltaomeg3
                deltaomeg3 = abs(omega3D(i)-omega3);
            end
            if abs(qD(i)-qmt) > deltaq
                deltaq = abs(qD(i)-qmt);
            end
            if abs(Omega3D(i)-Omega3) > deltaOmega3
                deltaOmega3 = abs(Omega3D(i)-Omega3);
            end
            if abs(i3D(i)-i3) > deltai3
                deltai3 = abs(i3D(i)-i3);
            end
        end
        
    end
    clear a12 a3 fm3;
    %---------------------------------------------------------------------------

    Sort0=sort(SumaCtvercu);     %sort the vector from the smallest element -> fh is the highest, fl the smallest
    fh=Sort0(param+1);
    fs=Sort0(param);
    fl=Sort0(1);
    sumactvercu(abacus)=fl;   %nejlepsi, nejmensi suma ctvercu odchylek
    
    for i=1:param+1
        if SumaCtvercu(i)==Sort0(param+1)     %gives the number of the worst vertex
            h=i;
        elseif SumaCtvercu(i)==Sort0(param)    %gives the number of the second worst vertex
            s=i;
        else
            if SumaCtvercu(i)==Sort0(1)    %gives the number of the best vertex
                l=i;
            end
        end
    end
    clear SumaCtvercu Sort0;
    
        if mod(abacus,50)==0
            PocitadloProGraf=PocitadloProGraf+1;
            SumaProGraf(PocitadloProGraf)=fl;
            SumLITE=SumaCtvercuLITE3(JDi,SigmaMin,Epo0,JD0D(l),PD(l),T0D(l),AD(l),p3D(l),omega3D(l),excen3D(l),qD(l));
            SumAstrom=CelkemAstroSigma(PocetAstrPouzitych,SigmaPosAng,SigmaSepar,HJD,T0D(l),p3D(l),excen3D(l),aD(l),Omega3D(l),omega3D(l),i3D(l),PosAng,Separ);
            SumaProGrafLITE(PocitadloProGraf)=SumLITE;
            SumaProGrafAstrom(PocitadloProGraf)=SumAstrom;
            disp(['LITE:', num2str(SumLITE,11), ' Astr:', num2str(SumAstrom,11), ' Total:', num2str(fl,20) ' Number: ', int2str(abacus-konst), '/', int2str(PocitadloVnejsi), '/',int2str(count)]);
            clear SumLITE SumAstrom;
        end        
        
    for i=1:param
        xc(i)=0;
    end
    
    for i=1:param+1                      %calculate the center of the simplexu without the worst vertex i<>h
        if i~=h
            xc(1)=xc(1)+1/param*(JD0D(i));
            xc(2)=xc(2)+1/param*(PD(i));
            xc(3)=xc(3)+1/param*(p3D(i));
            xc(4)=xc(4)+1/param*(T0D(i));
            xc(5)=xc(5)+1/param*(AD(i));
            xc(6)=xc(6)+1/param*(omega3D(i));
            xc(7)=xc(7)+1/param*(excen3D(i));
            xc(8)=xc(8)+1/param*(qD(i));
            xc(9)=xc(9)+1/param*(i3D(i));
            xc(10)=xc(10)+1/param*(Omega3D(i));
        end
    end
    %      1      2     3     4       5      6          7        8      9        10
    xh=[JD0D(h),PD(h),p3D(h),T0D(h),AD(h),omega3D(h),excen3D(h),qD(h),i3D(h),Omega3D(h)];      %coordinates of the worst vertex
    xl=[JD0D(l),PD(l),p3D(l),T0D(l),AD(l),omega3D(l),excen3D(l),qD(l),i3D(l),Omega3D(l)];      %coordinates of the best vertex
    xs=[JD0D(s),PD(s),p3D(s),T0D(s),AD(s),omega3D(s),excen3D(s),qD(s),i3D(s),Omega3D(s)];      %coordinates of the second worst vertex
    
    x=[JD0D',PD',p3D',T0D',AD',omega3D',excen3D',qD',i3D',Omega3D'];  %coordinates of all the 11 vertexes of simplex - in all 10 parametrs
    
    clear JD0D PD p3D T0D AD omega3D excen3D qD i3D Omega3D;
    
    xalfa=(1+alfa)*xc-alfa*xh;    %reflection             !|
%   xbeta=(1-beta)*xc+beta*xh;    %contraction            !|
%   xgama=(1-gama)*xc+gama*xh;    %expansion              !|
    xdelta=xl+delta*(xh-xl);      %shrinkage              !|
%   for beta and gama see lower !

    %-------zde vyjadreni funkcni hodnoty funkce "v bode xalfa"---------
    argument12 = abs(173.14*xalfa(5)/(sin(xalfa(9)*pi/180)*sqrt(1-xalfa(7)^2*(cos(xalfa(6)*pi/180))^2)));
    fm3=1/(xalfa(3)/365.24)^2*((173.14*xalfa(5)/sqrt(1-(xalfa(7)*cos(xalfa(6)*pi/180))^2 ))^3);   %mass function
    a3=abs(argument12*M12/(SpoctiHmotnost(xalfa(9),M12,fm3)));
    xalfa(11) = 180/pi*60*60*asin((argument12+a3)/vzdalenostAU);   %uhlova poloosa obehu v arcsec
    clear argument12 fm3 a3;
    SumaCtvercuAlfa = SumaCtvercuLITE3(JDi,SigmaMin,Epo0,xalfa(1),xalfa(2),xalfa(4),xalfa(5),xalfa(3),xalfa(6),xalfa(7),xalfa(8)) + CelkemAstroSigma(PocetAstrPouzitych,SigmaPosAng,SigmaSepar,HJD,xalfa(4),xalfa(3),xalfa(7),xalfa(11),xalfa(10),xalfa(6),xalfa(9),PosAng,Separ);
    %-------------------------------------------------------------------
   
    if SumaCtvercuAlfa < fl
        xgama=(1-gama)*xc+gama*((1+alfa)*xc-alfa*xh);     %xbeta(xalfa(xh)) !
        %-------zde vyjadreni funkcni hodnoty funkce "v bode xgama"---------
        argument12 = abs(173.14*xgama(5)/(sin(xgama(9)*pi/180)*sqrt(1-xgama(7)^2*(cos(xgama(6)*pi/180))^2)));
        fm3=1/(xgama(3)/365.24)^2*((173.14*xgama(5)/sqrt(1-(xgama(7)*cos(xgama(6)*pi/180))^2 ))^3);   %mass function
        a3=abs(argument12*M12/(SpoctiHmotnost(xgama(9),M12,fm3)));
        xgama(11) = 180/pi*60*60*asin((argument12+a3)/vzdalenostAU);   %uhlova poloosa obehu v arcsec
        clear argument12 fm3 a3;
        SumaCtvercuGama = SumaCtvercuLITE3(JDi,SigmaMin,Epo0,xgama(1),xgama(2),xgama(4),xgama(5),xgama(3),xgama(6),xgama(7),xgama(8)) + CelkemAstroSigma(PocetAstrPouzitych,SigmaPosAng,SigmaSepar,HJD,xgama(4),xgama(3),xgama(7),xgama(11),xgama(10),xgama(6),xgama(9),PosAng,Separ);
        %-------------------------------------------------------------------
        if SumaCtvercuGama < SumaCtvercuAlfa
            for i=1:param
                x(h,i)=xgama(i);
            end
            Inp(abacus-konst)=char('g');
        else
            for i=1:param
                x(h,i)=xalfa(i);
            end
            Inp(abacus-konst)=char('a');
        end
           
    else
        if SumaCtvercuAlfa <= fs
            for i=1:param
                x(h,i)=xalfa(i);
            end
             Inp(abacus-konst)=char('a');
         else
             if SumaCtvercuAlfa > fh
                xbeta=(1-beta)*xc+beta*xh;
                %-------zde vyjadreni funkcni hodnoty funkce "v bode xbeta"--------
                argument12 = abs(173.14*xbeta(5)/(sin(xbeta(9)*pi/180)*sqrt(1-xbeta(7)^2*(cos(xbeta(6)*pi/180))^2)));
                fm3=1/(xbeta(3)/365.24)^2*((173.14*xbeta(5)/sqrt(1-(xbeta(7)*cos(xbeta(6)*pi/180))^2 ))^3);   %mass function
                a3=abs(argument12*M12/(SpoctiHmotnost(xbeta(9),M12,fm3)));
                xbeta(11) = 180/pi*60*60*asin((argument12+a3)/vzdalenostAU);    %uhlova poloosa obehu v arcsec
                clear argument12 fm3 a3;
                SumaCtvercuBeta = SumaCtvercuLITE3(JDi,SigmaMin,Epo0,xbeta(1),xbeta(2),xbeta(4),xbeta(5),xbeta(3),xbeta(6),xbeta(7),xbeta(8)) + CelkemAstroSigma(PocetAstrPouzitych,SigmaPosAng,SigmaSepar,HJD,xbeta(4),xbeta(3),xbeta(7),xbeta(11),xbeta(10),xbeta(6),xbeta(9),PosAng,Separ);
                %------------------------------------------------------------------
            else
                xbeta=(1-beta)*xc+beta*((1+alfa)*xc-alfa*xh);     %xbeta(xalfa(xh)) !
                %-------zde vyjadreni funkcni hodnoty funkce "v bode xbeta"--------
                argument12 = abs(173.14*xbeta(5)/(sin(xbeta(9)*pi/180)*sqrt(1-xbeta(7)^2*(cos(xbeta(6)*pi/180))^2)));
                fm3=1/(xbeta(3)/365.24)^2*((173.14*xbeta(5)/sqrt(1-(xbeta(7)*cos(xbeta(6)*pi/180))^2 ))^3);   %mass function
                a3=abs(argument12*M12/(SpoctiHmotnost(xbeta(9),M12,fm3)));
                xbeta(11) = 180/pi*60*60*asin((argument12+a3)/vzdalenostAU);   %uhlova poloosa obehu v arcsec
                clear argument12 fm3 a3;
                SumaCtvercuBeta = SumaCtvercuLITE3(JDi,SigmaMin,Epo0,xbeta(1),xbeta(2),xbeta(4),xbeta(5),xbeta(3),xbeta(6),xbeta(7),xbeta(8)) + CelkemAstroSigma(PocetAstrPouzitych,SigmaPosAng,SigmaSepar,HJD,xbeta(4),xbeta(3),xbeta(7),xbeta(11),xbeta(10),xbeta(6),xbeta(9),PosAng,Separ);
                %------------------------------------------------------------------
            end
            if SumaCtvercuBeta > fh
                for j=1:param+1
                   for i=1:param
                       x(j,i)=xl(i)+delta*(x(j,i)-xl(i));
                   end
                end
                Inp(abacus-konst)=char('d');
            else
                for i=1:param
                    x(h,i)=xbeta(i);
                end
                Inp(abacus-konst)=char('b');
            end
        end
    end
    clear JD0D PD p3D T0D AD omega3D excen3D qD i3D Omega3D;

    for i=1:param+1   %arbitrariness to which vertexes assign which values, in fact we don't know which is now the best and the worst
        JD0D(i)=x(i,1);
        PD(i)=x(i,2);
        p3D(i)=x(i,3);
        T0D(i)=x(i,4);
        if x(i,5) < 0
            AD(i)=-(x(i,5));     %negative amplitudes ignore
        else
            AD(i)=x(i,5);
        end
        omega3D(i)=1/100000000*mod(round((100000000*x(i,6))),36000000000);
        excen3D(i)=abs(x(i,7));
        if excen3D(i) >= MaxExc
           excen3D(i)=MaxExc;
        end
        qD(i)=abs(x(i,8));
        i3D(i)=1/100000000*mod(round((100000000*x(i,9))),36000000000);
%         if i3D(i) > 180      %specialni prevod inklinace ze III. a IV. kvadrantu do I. a II.
%             i3D(i)=360-i3D(i);
%         end
        Omega3D(i)=1/100000000*mod(round((100000000*x(i,10))),36000000000);
    end
end    %k tomu while abacus < count !!

disp([' ']);
disp('Here are shown the individual simplex steps. a-reflection, b-contraction, d-shrinkage, g-expansion');
disp(Inp);

JD00=JD0D(l);
P=PD(l);
p3=p3D(l);
T0=T0D(l);
A=AD(l);
omega3=omega3D(l);
excen3=excen3D(l);
qmt=qD(l);
i3=i3D(l);
Omega3=Omega3D(l);

clear JD0D PD p3D T0D AD omega3D excen3D qD i3D Omega3D;

a12=abs(173.14*A/(sin(i3*pi/180)*sqrt(1-excen3^2*(cos(omega3*pi/180))^2)));  %poloosa obehu 12.slozky v AU
fm3=1/(p3/365.24)^2*((173.14*A/sqrt(1-(excen3*cos(omega3*pi/180))^2 ))^3);   %mass function,3.
m3def=SpoctiHmotnost(i3,M12,fm3);
a3=a12*M12/m3def;
a =180/pi*60*60*asin((a12+a3)/vzdalenostAU);   %uhlova poloosa obehu v arcsec

disp([' ']);
disp(['JD00: ',num2str(JD00,'%8.8f'),' ']);
disp(['Period: ',num2str(P,'%5.11f'),' day']);

disp(['Period of the 3. body: ',num2str(p3,'%6.6f'),' days']);
disp(['Period of the 3. body: ',num2str(p3/365.24,'%3.5f'),' years']);
disp(['Periastron passage: ',num2str(T0,'%8.4f'),' HJD']);
disp(['Semiamplitude of the LITE: ',num2str(A,'%1.8f'),' days']);
disp(['Argument of periastron: ',num2str(omega3,'%3.5f'),' degree']);
disp(['Eccentricity of the 3.body orbit: ',num2str(excen3,'%1.6f')]);
disp(['Mass transfer rate: ',num2str(qmt)]);
disp(['Mass function of the 3. body: ',num2str(fm3),' M_Sun']);

disp(['Inclination: ',num2str(i3,'%6.5f'),' deg']);
disp(['Omega: ',num2str(Omega3,'%6.5f'),' deg']);
disp(['Semi major axis: ',num2str(a,'%6.4f'),' arcsec']);

% argument = (173.14*A/(sin(i3*pi/180)*sqrt(1-excen3^2*(cos(omega3*pi/180))^2)))/vzdalenostAU;
% disp(['Kriticky parametr: ',num2str(argument,'%6.6f'),' ']);

disp(['Altogether: ',int2str(N), 'm + ',int2str(PocetAstrPouzitych),'a   measurements']);
disp(['And from minimum times ',int2str(remove),' neglected']);
disp(['The computation ran ', int2str(PocitadloVnejsi), '/',int2str(count)  ' times.']);

disp([' ']);
disp(['Error JD0: ',num2str(deltaJD,'%5.5f'),' => ',num2str(100*deltaJD/JD00,'%5.4f'),' %']);
disp(['Error P: ',num2str(deltaP,'%5.10f'),' day => ',num2str(100*deltaP/P,'%5.4f'),' %']);
disp(['Error p3: ',num2str(deltap3,'%8.4f'),' day => ',num2str(100*deltap3/p3,'%5.4f'),' %']);
disp(['Error T0: ',num2str(deltaT0,'%8.4f'),' => ',num2str(100*deltaT0/T0,'%5.4f'),' %']);
disp(['Error A: ',num2str(deltaA,'%3.8f'),' day => ',num2str(100*deltaA/A,'%5.4f'),' %']);
disp(['Error e: ',num2str(deltaexcen3,'%3.7f'),' => ',num2str(100*deltaexcen3/excen3,'%5.4f'),' %']);
disp(['Error omega3: ',num2str(deltaomeg3,'%5.4f'),' deg => ',num2str(100*deltaomeg3/omega3,'%5.4f'),' %']);
disp(['Error i3: ',num2str(deltai3,'%5.4f'),' deg => ',num2str(100*deltai3/i3,'%5.4f'),' %']);
disp(['Error Omega: ',num2str(deltaOmega3,'%5.4f'),' deg => ',num2str(100*deltaOmega3/Omega3,'%5.4f'),' %']);

if PocitadloVnejsi < count    %podminka ukonceni celeho cyklu!!!
    contin = 1;
else
    contin = 0;
end

end   %end of the whole cycle !!

%--------------vykresleni obrazku ------------------>
clear O E11 E21 B1 B2 Occ1 Occ2 ;

O=JDi-JD00-P*Epo0;       %difference O-C

minimumE=1000*floor(min(Epo0)/1000);
maximumE=1000*ceil(max(Epo0)/1000);
minimmaxim=MinMax(O,Weight,N);
minimumO=Minimum(O,Weight,N)-0.018;
maximumO=Maximum(O,Weight,N)+0.018;
clear minimmaxim;

j=1;
k=1;
for i = 1:N
   switch round(10*abs(Epo0(i)-round(Epo0(i))))
   case 0
      E11(j)=Epo0(i);    %primar minimum
      Occ1(j)=O(i);
      B1(j)=Weight(i);
      JD01(j)=JDi(i);
      j=j+1;
   case 5            %secondar minimum
      E21(k)=Epo0(i);
      Occ2(k)=O(i);
      B2(k)=Weight(i);
      JD02(k)=JDi(i);
      k=k+1;
   end
end

m=1;
n=1;
o=1;
o1=1;
for i = 1:j-1     %primar minimum
   switch B1(i)
   case 1        %visual primar minimum
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 3       %photographic prim.min worse quality
      E1pp(o1)=E11(i);
      O1pp(o1)=Occ1(i);
      o1=o1+1;
   case 5        %photographic primar minimum
      E1p(o)=E11(i);
      O1p(o)=Occ1(i);
      o=o+1;
   case 10       %ccd primar minimum
      E1c(m)=E11(i);
      O1c(m)=Occ1(i);
      m=m+1;
   end
end

p=1;
q=1;
r=1;
o2=1;
for i = 1:k-1     %secondar minimum
   switch B2(i)
   case 1         %visual secondar minimum
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 3       %photographic sec.min worse quality
      E2pp(o2)=E21(i);
      O2pp(o2)=Occ2(i);
      o2=o2+1;
   case 5         %photographic secondar minimum
      E2p(q)=E21(i);
      O2p(q)=Occ2(i);
      q=q+1;
   case 10        %ccd secondar minimum
      E2c(r)=E21(i);
      O2c(r)=Occ2(i);
      r=r+1;
   end
end

Ep=minimumE:(maximumE-minimumE)/1000:maximumE;       %plot a curve
JDi0=Ep*P+JD00;
Oc=OminusC(JDi0,T0,A,p3,omega3,excen3)+10^(-10)*qmt*Ep.*Ep;
OnlyMT=+10^(-10)*qmt*Ep.*Ep;

%-------------- 
clear CC;
CC=['3.txt'];
BB=char(Star);
QQ=sprintf([BB CC]);

OutputData=[JDi0; Ep; Oc; OnlyMT];

BB=char(Star);
%-------------- O U T P U T   DATA FILE --------------->>>
fid = fopen(QQ,'w');
fprintf(fid,'%s',BB,': JDi -- Epoch -- Total -- OnlyParab');
fprintf(fid,'%s\n','');
fprintf(fid,'%12.6f   %6.5f   %2.6f   %2.6f\n',OutputData);
status=fclose('all');
%-------------- 
clear OutputData QQ BB CC fid;

minJD=minimumE*P+JD00-2400000;
maxJD=maximumE*P+JD00-2400000;
minDate=JulToDate(minJD+2400000);
maxDate=JulToDate(maxJD+2400000);
minPer=minimumO/P;
maxPer=maximumO/P;

%-----------------------------------------------------------------------
figure(5);
clf;
if m > 1 plot(E1c,O1c,'k.','MarkerSize',17); end   %prim ccd min
hold on
if n > 1 plot(E1v,O1v,'k.','MarkerSize',6); end    %prim vis min
if o > 1 plot(E1p,O1p,'k.','MarkerSize',12); end   %prim phot min
if p > 1 plot(E2v,O2v,'ko','MarkerSize',2); end    %sec vis min
if q > 1 plot(E2p,O2p,'ko','MarkerSize',3); end    %sec phot min
if r > 1 plot(E2c,O2c,'ko','MarkerSize',4); end    %sec ccd min
if o1 > 1 plot(E1pp,O1pp,'k.','MarkerSize',8); end   %prim phot min worse quality
if o2 > 1 plot(E2pp,O2pp,'ko','MarkerSize',2); end   %prim phot min worse quality
plot(Ep,Oc,'r-');
set(gca,'FontSize',[12]);
axis([minimumE maximumE minimumO maximumO]);
set(gca,'XAxisLocation','bottom', 'FontSize', 12);
set(gca,'box','off');
set(gca,'YAxisLocation','left', 'FontSize', 12);
%set(gca,'PlotBoxAspectRatio',[1.8 1 1]);
set(gca,'PlotBoxAspectRatio',[2.4 1 1]);
xlabel('Epoch', 'FontSize', 12);
set(gca,'FontSize',[12]);
if (maximumE-minimumE) < 8000
    set(gca,'XTick',[ -6000.0 -5000.0  -4000.0 -3000.0 -2000.0 -1000.0 0.0 1000.0 2000.0 3000.0 4000.0 ]);
    set(gca,'XTickLabel','-6000|-5000|-4000|-3000|-2000|-1000|0|1000|2000|3000|4000');
elseif ((maximumE-minimumE) >= 7000) & ((maximumE-minimumE) < 15000)
    set(gca,'XTick',[ -12000.0 -10000.0 -8000.0 -6000.0 -4000.0 -2000.0 0.0 2000.0 4000.0 6000.0 8000.0 10000.0 12000.0]);
    set(gca,'XTickLabel','-12000|-10000|-8000|-6000|-4000|-2000|0|2000|4000|6000|8000|10000|12000');
else
    if ((maximumE-minimumE) >= 15000) & ((maximumE-minimumE) < 40000)
        set(gca,'XTick',[ -25000.0 -20000.0 -15000.0 -10000.0 -5000.0 0.0 5000.0 10000.0 15000.0 20000.0 25000.0 ]);
        set(gca,'XTickLabel','-25000|-20000|-15000|-10000|-5000|0|5000|10000|15000|20000|25000');
    else
        set(gca,'XTick',[ -40000.0 -30000.0 -20000.0 -10000.0 0.0 10000.0 20000.0 ]);
        set(gca,'XTickLabel','-40000|-30000|-20000|-10000|0|10000|20000');
    end
end
ylabel('O-C (days)', 'FontSize', 12);

%RECT=[0.13 0.80503 0.775 0.0001];
RECT=[0.13 0.733603 0.775 0.0001];
axes('position', RECT);
set(gca,'FontSize',[12]);
axis([minDate maxDate -0.01 0.01]);
set(gca,'TickDir','out', 'FontSize', 12);
set(gca,'XAxisLocation','top');
set(gca,'XAxisLocation','bottom');

RECT=[0.13 0.733603 0.775 0.0001];
axes('position', RECT);
set(gca,'FontSize',[12]);
axis([minJD+2400000 maxJD+2400000 -0.0001 0.0001]);
set(gca,'XLimMode','manual');
if (maxJD-minJD) < 7000 %cca 19 let
    set(gca,'XTick',[ 2417000.0 2418000.0 2419000.0 2420000.0 2421000.0 2422000.0 2423000.0 2424000.0 2425000.0  2426000.0 2427000.0 2428000.0 2429000.0 2430000.0 2431000.0 2432000.0 2433000.0 2434000.0 2435000.0 2436000.0 2437000.0 2438000.0 2439000.0 2440000.0 2441000.0 2442000.0 2443000.0 2444000.0 2445000.0 2446000.0 2447000.0 2448000.0 2449000.0 2450000.0 2451000.0 2452000.0 2453000.0 2454000.0 2455000.0 2456000.0 2457000.0 2458000.0 2459000.0 2460000.0 ]);
    set(gca,'XTickLabel','2417000|2418000|2419000|2420000|2421000|2422000|2423000|2424000|2425000| 2426000|2427000|2428000|2429000|2430000|2431000|2432000|2433000|2434000|2435000|2436000|2437000|2438000|2439000|2440000|2441000|2442000|2443000|2444000|2445000|2446000|2447000|2448000|2449000|2450000|2451000|2452000|2453000|2454000|2455000|2456000|2457000|2458000|2459000|2460000');    
elseif ((maxJD-minJD) >= 7000) & ((maxJD-minJD) < 15000)  %od cca 19 let do 27 let
    set(gca,'XTick',[ 2418000.0 2420000.0 2422000.0 2424000.0 2426000.0 2428000.0 2430000.0 2432000.0 2434000.0 2436000.0 2438000.0 2440000.0 2442000.0 2444000.0 2446000.0 2448000.0 2450000.0 2452000.0 2454000.0 2456000.0 2458000.0 2460000.0 ]);
    set(gca,'XTickLabel',' 2418000|2420000|2422000|2424000|2426000|2428000|2430000|2432000|2434000|2436000|2438000|2440000|2442000|2444000|2446000|2448000|2450000|2452000|2454000|2456000|2458000|2460000');
else
    if ((maxJD-minJD) >= 15000) & ((maxJD-minJD) < 40000)  %od 27 let do cca 95 let
        set(gca,'XTick',[ 2415000.0 2420000.0 2425000.0 2430000.0 2435000.0 2440000.0 2445000.0 2450000.0 2455000.0 2460000.0 ]);
        set(gca,'XTickLabel','2415000|2420000|2425000|2430000|2435000|2440000|2445000|2450000|2455000|2460000');
    else
        set(gca,'XTick',[ 2420000.0 2430000.0 2440000.0 2450000.0 2460000.0 ]);
        set(gca,'XTickLabel','2420000|2430000|2440000|2450000|2460000');
    end
end
set(gca,'TickDir','out', 'FontSize', 12);
set(gca,'XAxisLocation','top', 'FontSize', 12);

RECT=[0.9046 0.302 0.0001 0.432];
axes('position', RECT);
set(gca,'FontSize',[12]);
axis([-0.01 0.01 minPer maxPer]);
set(gca,'TickDir','in');
set(gca,'YAxisLocation','right', 'FontSize', 12);
ylabel('O-C (Period)', 'FontSize', 12);

clear CC;
CC=['_3.png'];
BB=char(Star);
QQ=sprintf([BB CC]);
print('-f', '-dpng', QQ);      %transform the O-C diagram into the .png format
clear CCa;
CCa=['_3.eps'];
QQ=sprintf([BB CCa]);
print('-f', '-depsc', QQ);      %transform the O-C diagram into the .eps format
hold off
clear AA BB CC DD QQ;
clear Oc Ep Oc3 JDi0;
%---------------------------------------------------------------
%here the figure after subtraction of MT but with the LITE,3 curve
% 
% O=JDi-JD00-P*Epo0-10^(-10)*qmt*Epo0.*Epo0;          %residuum ((O-C)-MT) 
% 
% j=1;
% k=1;
% for i = 1:N
%    switch round(10*abs(Epo0(i)-round(Epo0(i))))
%    case 0
%       E11(j)=Epo0(i);    %prim minimum
%       Occ1(j)=O(i);
%       B1(j)=Weight(i);
%       j=j+1;
%    case 5            %sec minimum
%       E21(k)=Epo0(i);
%       Occ2(k)=O(i);   
%       B2(k)=Weight(i);
%       k=k+1;
%    end
% end
% 
% m=1;
% n=1;
% o=1;
% o1=1;
% for i = 1:j-1     %prim min
%    switch B1(i)
%    case 1        %vis prim min
%       E1v(n)=E11(i);
%       O1v(n)=Occ1(i);
%       n=n+1;
%    case 3        %phot prim min, worse
%       E1pp(o1)=E11(i);
%       O1pp(o1)=Occ1(i);
%       o1=o1+1;
%    case 5        %phot prim min
%       E1p(o)=E11(i);
%       O1p(o)=Occ1(i);
%       o=o+1;
%    case 10        %ccd prim min
%       E1c(m)=E11(i);
%       O1c(m)=Occ1(i);
%       m=m+1;
%    end
% end
% 
% p=1;
% q=1;
% r=1;
% o2=1;
% for i = 1:k-1     %sec min
%    switch B2(i)
%    case 1         %vis sec min
%       E2v(p)=E21(i);
%       O2v(p)=Occ2(i);
%       p=p+1;
%    case 3        %phot sec min, worse
%       E2pp(o2)=E21(i);
%       O2pp(o2)=Occ2(i);
%       o2=o2+1;
%   case 5         %phot sec min
%       E2p(q)=E21(i);
%       O2p(q)=Occ2(i);
%       q=q+1;
%    case 10        %ccd sec min
%       E2c(r)=E21(i);
%       O2c(r)=Occ2(i);
%       r=r+1;
%    end
% end
% 
% minimumO=Minimum(O,Weight,N)-0.02;
% maximumO=Maximum(O,Weight,N)+0.02;
% minPer=minimumO/P;
% maxPer=maximumO/P;
% 
% clear Ep;
% % Ep=minimumE:10:maximumE;        %plot a curve
% % JDi0=Ep*P+JD00+10^(-10)*qmt*Ep.*Ep;
% % Oc=OminusC(JDi0,T0,A,p3,omega3,excen3);
% 
% minJD=minimumE*P+JD00-2400000;
% maxJD=maximumE*P+JD00-2400000;
% minDate=JulToDate(minJD+2400000);
% maxDate=JulToDate(maxJD+2400000);

% figure(6);
% clf;
% if m > 1 plot(E1c,O1c,'k.','MarkerSize',17); end   %prim ccd min
% hold on
% if n > 1 plot(E1v,O1v,'k.','MarkerSize',6); end    %prim vis min
% if o > 1 plot(E1p,O1p,'k.','MarkerSize',12); end   %prim phot min
% if p > 1 plot(E2v,O2v,'ko','MarkerSize',2); end    %sec vis min
% if q > 1 plot(E2p,O2p,'ko','MarkerSize',3); end    %sec phot min
% if r > 1 plot(E2c,O2c,'ko','MarkerSize',4); end    %sec ccd min
% if o1 > 1 plot(E1pp,O1pp,'k.','MarkerSize',8); end   %prim phot min worse quality
% if o2 > 1 plot(E2pp,O2pp,'ko','MarkerSize',2); end   %prim phot min worse quality
% plot(Ep,Oc,'r-');
% axis([minimumE maximumE minimumO maximumO]);
% set(gca,'XAxisLocation','bottom');
% set(gca,'box','off');
% set(gca,'YAxisLocation','left');
% xlabel('Epoch');
% set(gca,'XTickLabel','-40000|-35000|-30000|-25000|-20000|-15000|-10000|-5000|0|5000|10000|15000|20000|25000|30000|35000|40000|45000|50000');
% set(gca,'XTick',[ -40000.0 -35000.0 -30000.0 -25000.0 -20000.0 -15000.0 -10000.0 -5000.0 0.0 5000.0 10000.0 15000.0 20000.0 25000.0 30000.0 35000.0 40000.0 45000.0 50000.0 ]);
% ylabel('O-C (days)');
% 
% RECT=[0.13 0.9242 0.775 0.0001];
% axes('position', RECT);
% axis([minJD+2400000 maxJD+2400000 -0.001 0.001]);
% set(gca,'XLimMode','manual');
% % set(gca,'XTick',[ 2425000.0 2430000.0 2435000.0 2440000.0 2445000.0 2450000.0 2455000.0 ]);
% % set(gca,'XTickLabel','2425000|2430000|2435000|2440000|2445000|2450000|2455000');
% set(gca,'TickDir','out');
% set(gca,'XAxisLocation','top');
% title(' The (O-C) diagram V819 Her after subtraction of MT');    %residuals after the subtraction of the LITE
% 
% RECT=[0.9046 0.11 0.0001 0.815];
% axes('position', RECT);
% axis([-0.01 0.01 minPer maxPer]);
% set(gca,'TickDir','in');
% set(gca,'YAxisLocation','right');
% ylabel('O-C (Period)');
% 
% RECT=[0.13 0.9242 0.775 0.0001];
% axes('position', RECT);
% axis([minDate maxDate -0.01 0.01]);
% set(gca,'TickDir','out');
% set(gca,'XAxisLocation','bottom');
% % set(gca,'XTick',[1950.0 1960.0 1970.0 1980.0 1990.0 2000.0 2010.0]);
% % set(gca,'XTickLabel','1940|1950|1960|1970|1980|1990|2000| '); 
% 
% print -depsc V819Her_Only3Body.eps;      %transfor the O-C diagram into the .eps format
% hold off
%--------------------------------------------------------------
% figure(7);
% clf;
% if m > 1 plot(E1c,O1c,'k.','MarkerSize',17); end   %prim ccd min
% hold on
% if n > 1 plot(E1v,O1v,'k.','MarkerSize',6); end    %prim vis min
% if o > 1 plot(E1p,O1p,'k.','MarkerSize',12); end   %prim phot min
% if p > 1 plot(E2v,O2v,'ko','MarkerSize',2); end    %sec vis min
% if q > 1 plot(E2p,O2p,'ko','MarkerSize',3); end    %sec phot min
% if r > 1 plot(E2c,O2c,'ko','MarkerSize',4); end    %sec ccd min
% if o1 > 1 plot(E1pp,O1pp,'k.','MarkerSize',8); end   %prim phot min worse quality
% if o2 > 1 plot(E2pp,O2pp,'ko','MarkerSize',2); end   %prim phot min worse quality
% plot(Ep,Oc,'r-');
% axis([minimumE maximumE minimumO maximumO]);
% set(gca,'XAxisLocation','bottom', 'FontSize', 12);
% set(gca,'box','off');
% set(gca,'YAxisLocation','left', 'FontSize', 12);
% set(gca,'PlotBoxAspectRatio',[2.4 1 1]);
% xlabel('Epoch', 'FontSize', 12);
% set(gca,'XTickLabel','-40000|-35000|-30000|-25000|-20000|-15000|-10000|-5000|0|5000|10000|15000|20000|25000|30000|35000|40000|45000|50000');
% set(gca,'XTick',[ -40000.0 -35000.0 -30000.0 -25000.0 -20000.0 -15000.0 -10000.0 -5000.0 0.0 5000.0 10000.0 15000.0 20000.0 25000.0 30000.0 35000.0 40000.0 45000.0 50000.0 ]);
% ylabel('O-C (days)', 'FontSize', 12);
% 
% RECT=[0.13 0.733603 0.775 0.0001];
% axes('position', RECT);
% axis([minJD+2400000 maxJD+2400000 -0.0001 0.0001]);
% set(gca,'XLimMode','manual');
% set(gca,'XTickLabel','2425000|2430000|2435000|2440000|2445000|2450000|2455000');
% set(gca,'XTick',[2425000.0 2430000.0 2435000.0 2440000.0 2445000.0 2450000.0 2455000.0]);
% set(gca,'TickDir','out');
% set(gca,'XAxisLocation','top', 'FontSize', 12);
% % title(' The (O-C) diagram V819 Her after subtraction of MT');    %residuals after the subtraction of the LITE
% 
% RECT=[0.9046 0.302 0.0001 0.432];
% axes('position', RECT);
% axis([-0.01 0.01 minPer maxPer]);
% set(gca,'TickDir','in', 'FontSize', 12);
% set(gca,'YAxisLocation','right');
% ylabel('O-C (Period)', 'FontSize', 12);
% 
% RECT=[0.13 0.733603 0.775 0.0001];
% axes('position', RECT);
% axis([minDate maxDate -0.01 0.01]);
% set(gca,'TickDir','out');
% set(gca,'XAxisLocation','bottom', 'FontSize', 12);
% % set(gca,'XTick',[1950.0 1960.0 1970.0 1980.0 1990.0 2000.0 2010.0]);
% % set(gca,'XTickLabel','1940|1950|1960|1970|1980|1990|2000| '); 
% 
% print -depsc V819Her_Only3body3.eps;      %transfor the O-C diagram into the .eps format
% hold off
% %-----------------------------------------------------------------------
% % and also after the subtraction of the LITE -------->>
% 
% Ocx=OminusC(JDi,T0,A,p3,omega3,excen3);
% O=JDi-JD00-P*Epo0-Ocx-10^(-10)*qmt*Epo0.*Epo0;
% 
% minimmaxim=MinMax(O,Weight,N);
% minimumO=minimmaxim(1)-0.01;
% maximumO=minimmaxim(2)+0.01;
% clear minimmaxim;
% minPer=minimumO/P;
% maxPer=maximumO/P;
% 
% j=1;
% k=1;
% for i = 1:N
%    switch round(10*abs(Epo0(i)-round(Epo0(i))))
%    case 0
%       E11(j)=Epo0(i);    %prim minimum
%       Occ1(j)=O(i);
%       B1(j)=Weight(i);
%       j=j+1;
%    case 5            %sec minimum
%       E21(k)=Epo0(i);
%       Occ2(k)=O(i);   
%       B2(k)=Weight(i);
%       k=k+1;
%    end
% end
% 
% m=1;
% n=1;
% o=1;
% o1=1;
% for i = 1:j-1     %prim min
%    switch B1(i)
%    case 1        %vis prim min
%       E1v(n)=E11(i);
%       O1v(n)=Occ1(i);
%       n=n+1;
%    case 3        %phot prim min, worse
%       E1pp(o1)=E11(i);
%       O1pp(o1)=Occ1(i);
%       o1=o1+1;
%    case 5        %phot prim min
%       E1p(o)=E11(i);
%       O1p(o)=Occ1(i);
%       o=o+1;
%    case 10        %ccd prim min
%       E1c(m)=E11(i);
%       O1c(m)=Occ1(i);
%       m=m+1;
%    end
% end
% 
% p=1;
% q=1;
% r=1;
% o2=1;
% for i = 1:k-1     %sec min
%    switch B2(i)
%    case 1         %vis sec min
%       E2v(p)=E21(i);
%       O2v(p)=Occ2(i);
%       p=p+1;
%    case 3        %phot sec min, worse
%       E2pp(o2)=E21(i);
%       O2pp(o2)=Occ2(i);
%       o2=o2+1;
%   case 5         %phot sec min
%       E2p(q)=E21(i);
%       O2p(q)=Occ2(i);
%       q=q+1;
%    case 10        %ccd sec min
%       E2c(r)=E21(i);
%       O2c(r)=Occ2(i);
%       r=r+1;
%    end
% end
% 
% E=minimumE:10:maximumE;
% O=0+0.0000000000001*E;
% 
% figure(8);
% clf;
% if m > 1 plot(E1c,O1c,'.','MarkerSize',17); end   %prim ccd min
% hold on
% if n > 1 plot(E1v,O1v,'.','MarkerSize',6); end    %prim vis min
% if o > 1 plot(E1p,O1p,'.','MarkerSize',12); end   %prim phot min
% if p > 1 plot(E2v,O2v,'o','MarkerSize',2); end    %sec vis min
% if q > 1 plot(E2p,O2p,'o','MarkerSize',3); end    %sec phot min
% if r > 1 plot(E2c,O2c,'o','MarkerSize',4); end    %sec ccd min
% if o1 > 1 plot(E1pp,O1pp,'.','MarkerSize',8); end   %prim phot min worse quality
% if o2 > 1 plot(E2pp,O2pp,'o','MarkerSize',2); end   %prim phot min worse quality
% plot(E,O,'k');
% axis([minimumE maximumE minimumO maximumO]);
% set(gca,'XAxisLocation','bottom');
% set(gca,'box','off');
% set(gca,'YAxisLocation','left');
% xlabel('Epoch');
% ylabel('(O-C)-(O-C)_{LITE} (days)');
% 
% RECT=[0.13 0.9242 0.775 0.0001];
% axes('position', RECT);
% axis([minDate maxDate -0.01 0.01]);
% %set(gca,'XTickLabel','-15000|-10000|-5000|0|5000|10000|15000');
% set(gca,'TickDir','out');
% set(gca,'XAxisLocation','top');
% title('Residuals in (O-C) diagram V819 Her');    %residuals after the subtraction of the LITE
% 
% RECT=[0.13 0.9242 0.775 0.0001];
% axes('position', RECT);
% axis([minJD+2400000 maxJD+2400000 -0.001 0.001]);
% set(gca,'XLimMode','manual');
% % set(gca,'XTickLabel','2425000|2430000|2435000|2440000|2445000|2450000|2455000');
% % set(gca,'XTick',[2425000.0 2430000.0 2435000.0 2440000.0 2445000.0 2450000.0 2455000.0]);
% set(gca,'TickDir','out');
% set(gca,'XAxisLocation','bottom');
% 
% RECT=[0.9046 0.11 0.0001 0.815];
% axes('position', RECT);
% axis([-0.01 0.01 minPer maxPer]);
% %set(gca,'XTickLabel','-15000|-10000|-5000|0|5000|10000|15000');
% set(gca,'TickDir','in');
% set(gca,'YAxisLocation','right');
% ylabel('O-C (Period)');
% 
% print -deps V819Her_Residuals.eps;      %transform the O-C diagram into the .eps format
% hold off

%----now plot the resultant figure with final parameters-------
j=0;
for HJDKrivky = YearToJul(YearAstr(1)):(p3/4000):(YearToJul(YearAstr(1))+p3);     %pro vykresleni krivky pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJDKrivky,T0,p3,excen3,a,Omega3,omega3,i3);
    xKrivka(j) = Hodnota(1);     %zde souradnice bodu krivky
    yKrivka(j) = Hodnota(2);
    clear Hodnota;
end
clear HJDKrivky;

j=0;
for i = 1:PocetAstrPouzitych     %zde jen teoreticke body na krivce pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJD(i),T0,p3,excen3,a,Omega3,omega3,i3);
    xOdBodu(j) = Hodnota(1);     %zde souradnice bodu krivky
    yOdBodu(j) = Hodnota(2);
    clear Hodnota;
end

figure(9);
plot(xBody,yBody,'k.','MarkerSize',13);
hold on
set(gca,'FontSize',[12]);
plot(0,0,'kx','MarkerSize',12);
plot(xOdBodu,yOdBodu,'r.','MarkerSize',5);  %body na teoreticke krivce
plot(xKrivka,yKrivka,'k.','MarkerSize',1);  % krivka samotna
for i = 1:PocetAstrPouzitych
    X=[xOdBodu(i),xBody(i)];
    Y=[yOdBodu(i),yBody(i)];
    line(X,Y);
    clear X Y;
end
xlabel('RA[mas]');
ylabel('DE[mas]');
axis([-0.08 0.08 -0.12 0.04]);
% set(gca,'XTick',[-0.20 -0.15 -0.10 -0.05 0.0 0.05 0.10 0.15 0.20 0.25 0.30 0.35 0.40 0.45 0.50 0.55 0.60 0.65 0.70]);
% set(gca,'XTickLabel','-200|-150|-100|-50|0|50|100|150|200|250|300|350|400|450|500|550|600|650|700');
% set(gca,'YTick',[-0.60 -0.55 -0.50 -0.45 -0.40 -0.35 -0.30 -0.25 -0.20 -0.15 -0.10 -0.05 0.0 0.05 0.10 0.15 0.20 0.25 0.30]);
% set(gca,'YTickLabel','-600|-550|-500|-450|-400|-350|-300|-250|-200|-150|-100|-50|0|50|100|150|200|250|300');
set(gca,'PlotBoxAspectRatio',[1 1 1]);

clear CC;
CC=['_Orbit.png'];
BB=char(Star);
QQ=sprintf([BB CC]);
print('-f', '-dpng', QQ);      %transform the O-C diagram into the .png format
clear CCa;
CCa=['_Orbit.eps'];
QQ=sprintf([BB CCa]);
print('-f', '-depsc', QQ);      %transform the O-C diagram into the .eps format
hold off
clear AA BB CC DD QQ;
%-------------------------------------------------------------------

%-------------- 
clear CC;
CC=['_Orbit.txt'];
BB=char(Star);
QQ=sprintf([BB CC]);

% OutputData=[xKrivka; yKrivka];

BB=char(Star);
%-------------- O U T P U T   DATA FILE --------------->>>
fid = fopen(QQ,'w');
fprintf(fid,'%s',BB,': Theoretical curve: X -- Y');
fprintf(fid,'%s\n','');
for i = 1:length(xKrivka)
    fprintf(fid,'%2.7f    %2.7f\n',xKrivka(i),yKrivka(i));
end
fprintf(fid,'%s\n','');
fprintf(fid,'%s\n','');
fprintf(fid,'%s',BB,': The data: observed X -- Y , theoretical X -- Y');
fprintf(fid,'%s\n','');
for i = 1:length(xBody)
    fprintf(fid,'%2.7f     %2.7f      %2.7f     %2.7f\n',xBody(i),yBody(i),xOdBodu(i),yOdBodu(i));
end
status=fclose('all');
%-------------- 
clear OutputData QQ BB CC fid;

clear xKrivka yKrivka;
%-----------------------------------------------------------------------

Acelk = (a12+a3)*149598000/696000;  %Acelk [R0]

%========chyba M3 ===============
chybap3=deltap3/365.24;
e=excen3;
 %omega3 %deg!
chybaomega=deltaomeg3 *pi/180;  %rad!

chybafm3 = (chybap3)^2 *((-2)*fm3/p3)^2 + (deltaA)^2*(3*fm3/A)^2 + (deltaexcen3)^2*(3*fm3*e*(cos(omega3*pi/180))^2/(1-e^2*(cos(omega3*pi/180))^2))^2 + (chybaomega)^2*(3*fm3*e^2*sin(2*omega3*pi/180)/(2*(1-e^2*(cos(omega3*pi/180)))))^2;
chybafm3=sqrt(chybafm3);

pocet=0;
zdar=0;
m3max=m3def;
for ii = i3-deltai3:(2*deltai3)/50:i3+deltai3
    for fm3i = fm3-chybafm3:(2*chybafm3)/50:fm3+chybafm3
        m3dalsi=abs(SpoctiHmotnost(ii,M12,fm3i));
        if abs(m3dalsi) > max(m3max)
            zdar=zdar+1;
            m3max(zdar) = m3dalsi;
             defi=ii;
             deffm3=fm3i;
        end
    end
end
mMaximalni=m3max(zdar);
clear zdar m3dalsi;

pocet=0;
zdar0=0;
m3min=m3def;
for ii = i3-deltai3:(2*deltai3)/50:i3+deltai3
    for fm3i = fm3-chybafm3:(2*chybafm3)/50:fm3+chybafm3
        m3dalsi=abs(SpoctiHmotnost(ii,M12,fm3i));
        if abs(m3dalsi) < min(m3min)
            zdar0=zdar0+1;
            m3min(zdar0) = m3dalsi;
%              defi0=ii;
%              deffm30=fm3i;
        end
    end
end
mMinimalni=m3min(zdar0);
clear zdar m3dalsi;
ChybaM3=max(m3def-mMinimalni,mMaximalni-m3def);

%-=====chyba a12 ======-
chybaa12=(chybafm3)^2*((1/3)*fm3^(-2/3)*(p3/365.24)^(2/3)/sin(i3*pi/180))^2 + (chybap3)^2*((2/3)*(p3/365.24)^(-1/3)*fm3^(1/3)/sin(i3*pi/180))^2 + (deltai3*pi/180)^2*((-1)*(sin(i3*pi/180))^(-2)*cos(i3*pi/180)*fm3^(1/3)*(p3/365.24)^(2/3))^2;
chybaa12=sqrt(chybaa12);

%----chyba par - chyba vzdal - chyba a3 - chyba a [arcs] ----
ChybaVzdalAU = (ErrPar)*abs((206265*cos(paralax/1000))/(1000*(sin(paralax/1000))^2));  % chyba vzdalenosti v AU

ChybaVzdalPC = ChybaVzdalAU/206265;

Chybaa3 = sqrt((chybaa12)^2*(M12/m3def)^2 + (ChybaM3)^2*(a12*M12/(m3def^2))^2);

Strevo = 180/pi*60*60/(vzdalenostAU*sqrt(1-((a12+a3)/vzdalenostAU)^2));

Chybaa=sqrt((chybaa12^2)*(Strevo^2) + (Chybaa3^2)*(Strevo^2) + (ChybaVzdalAU^2)*(Strevo*(a12+a3)/vzdalenostAU)^2);

ChybaAcelk=sqrt((149598000/696000)^2*(Chybaa3^2+chybaa12^2));


CC=['        ; 1=compute(fit), 0=not compute(fix)'];
BBa=char(Star);
QQ=sprintf([BBa CC]);
%-------------- O U T P U T --------------->>>
fid = fopen('Parameters.txt','w');
fprintf(fid,'%s\n',QQ');
fprintf(fid,'%9.8f',JD00);
fprintf(fid,'%s','    ');
fprintf(fid,'%3.8f',deltaJD);
fprintf(fid,'%s','    ');
fprintf(fid,'%1.0f',JD00F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','    HJD_0');
fprintf(fid,'%3.13f',P);
fprintf(fid,'%s','     ');
fprintf(fid,'%2.8f',deltaP);
fprintf(fid,'%s','    ');
fprintf(fid,'%1.0f',PF);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','    P [days]');
fprintf(fid,'%3.6f',p3);
fprintf(fid,'%s','        ');
fprintf(fid,'%4.6f',deltap3);
fprintf(fid,'%s','     ');
fprintf(fid,'%1.0f',p3F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','     p3(days)');
fprintf(fid,'%10.5f', T0);
fprintf(fid,'%s','      ');
fprintf(fid,'%2.5f',deltaT0);
fprintf(fid,'%s','      ');
fprintf(fid,'%1.0f',T0F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','     T0');
fprintf(fid,'%1.9f',A);
fprintf(fid,'%s','         ');
fprintf(fid,'%3.7f',deltaA);
fprintf(fid,'%s','     ');
fprintf(fid,'%1.0f',AF);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','     A(days)');
fprintf(fid,'%4.6f',omega3);
fprintf(fid,'%s','          ');
fprintf(fid,'%3.6f',deltaomeg3);
fprintf(fid,'%s','      ');
fprintf(fid,'%1.0f',omega3F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','     omega3 (deg)');
fprintf(fid,'%1.9f',excen3);
fprintf(fid,'%s','         ');
fprintf(fid,'%2.6f',deltaexcen3);
fprintf(fid,'%s','      ');
fprintf(fid,'%1.0f',excen3F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','     e3');
fprintf(fid,'%2.7f',qmt);
fprintf(fid,'%s','           ');
fprintf(fid,'%2.8f', 0);
fprintf(fid,'%s','     ');
fprintf(fid,'%1.0f',qmtF);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','    qmt');
fprintf(fid,'%6.8f',i3);
fprintf(fid,'%s','        ');
fprintf(fid,'%2.6f',deltai3);
fprintf(fid,'%s','      ');
fprintf(fid,'%1.0f',i3F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','     i3 [deg]');
fprintf(fid,'%5.8f',Omega3);
fprintf(fid,'%s','         ');
fprintf(fid,'%2.6f',deltaOmega3);
fprintf(fid,'%s','     ');
fprintf(fid,'%1.0f',Omega3F);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','    Omega [deg]');
fprintf(fid,'%6.8f',a);
fprintf(fid,'%s','          ');
fprintf(fid,'%2.8f', 0);
fprintf(fid,'%s','     ');
fprintf(fid,'%1.0f',0);
fprintf(fid,'%s','   ');
fprintf(fid,'%s\n','    a [arcsec] - not computed');
status=fclose('all');

BB=char(Star);
%-------------- O U T P U T --------------->>>
fid = fopen('Output.txt','w');
fprintf(fid,'%s\n',BB);
fprintf(fid,'%s\n','');
fprintf(fid,'%s','JD0 = ');
fprintf(fid,'%12.7f',JD00);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%3.7f',deltaJD);
fprintf(fid,'%s\n',' HJD');
fprintf(fid,'%s','P = ');
fprintf(fid,'%2.12f',P);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%2.12f',deltaP);
fprintf(fid,'%s\n',' days');
fprintf(fid,'%s\n','');
fprintf(fid,'%s','p3 = ');
fprintf(fid,'%3.4f',p3);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%3.8f',deltap3);
fprintf(fid,'%s\n',' days');
fprintf(fid,'%s','p3 = ');
fprintf(fid,'%5.4f',p3/365.24);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%3.8f',deltap3/365.24);
fprintf(fid,'%s\n',' years');
fprintf(fid,'%s','T0 = ');
fprintf(fid,'%10.3f',T0);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%8.8f',deltaT0);
fprintf(fid,'%s\n',' HJD');
fprintf(fid,'%s','A = ');
fprintf(fid,'%1.7f',A);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%1.6f',deltaA);
fprintf(fid,'%s\n',' days');
fprintf(fid,'%s','omega3 = ');
fprintf(fid,'%4.4f',omega3);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%3.6f',deltaomeg3);
fprintf(fid,'%s\n',' deg');
fprintf(fid,'%s','e3 = ');
fprintf(fid,'%1.7f',excen3);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%1.6f\n',deltaexcen3);
fprintf(fid,'%s','qmt = ');
fprintf(fid,'%4.5f',qmt);
fprintf(fid,'%s\n',' .10^(-10)');
fprintf(fid,'%s\n','');
fprintf(fid,'%s','inclination = ');
fprintf(fid,'%6.6f',i3);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%4.6f',deltai3);
fprintf(fid,'%s\n',' deg');
fprintf(fid,'%s','Omega = ');
fprintf(fid,'%5.6f',Omega3);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%3.6f',deltaOmega3);
fprintf(fid,'%s\n',' deg');
fprintf(fid,'%s','a = ');
fprintf(fid,'%6.6f',a);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%6.5f',Chybaa);
fprintf(fid,'%s\n',' arcsec - (not fitted, computed)');
fprintf(fid,'%s\n','');
fprintf(fid,'%s','f(m3) = ');
fprintf(fid,'%4.10f',fm3);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%4.10f',chybafm3);
fprintf(fid,'%s\n',' M_sun');
fprintf(fid,'%s','M3 = ');
fprintf(fid,'%4.9f',m3def);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%4.8f',ChybaM3);
fprintf(fid,'%s\n',' M_sun');
fprintf(fid,'%s\n','');
fprintf(fid,'%s','a12 = ');
fprintf(fid,'%4.9f',a12);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%4.8f',chybaa12);
fprintf(fid,'%s\n',' AU');
fprintf(fid,'%s','a3 = ');
fprintf(fid,'%4.9f',a3);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%4.8f',Chybaa3);
fprintf(fid,'%s\n',' AU');
fprintf(fid,'%s','Atotal = ');
fprintf(fid,'%4.9f',Acelk);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%4.8f',ChybaAcelk);
fprintf(fid,'%s\n',' R0');
fprintf(fid,'%s\n','');
fprintf(fid,'%s','Pi = ');
fprintf(fid,'%4.4f',paralax);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%4.4f',ErrPar);
fprintf(fid,'%s\n',' mas');
fprintf(fid,'%s','d = ');
fprintf(fid,'%4.3f',vzdalenostAU/206265);
fprintf(fid,'%s',' +/- ');
fprintf(fid,'%4.3f',ChybaVzdalPC);
fprintf(fid,'%s\n',' pc');
fprintf(fid,'%s\n','');
fprintf(fid,'%s','SUM of the square residuals: ');
fprintf(fid,'%1.13f\n',fl);
status=fclose('all');
%----------------------------------------------------------------------- 
% figure(12);
% % plot(PocitadloProGraf,SumaProGraf,'k.','MarkerSize',1);
% plot(SumaProGraf,'.');
% %----------------------------------------------------------------------- 

% %%------------- 3D OBRAZEK !!! -------------------->>>
% clear i j a12 fm3 a3 1 SumaCtvercu Z Xx Y;
% i=0;
% for omega3 = 180:20:330
%    i=i+1;
%    Xx(i)=omega3;
%    j=0;
%    for excen3 = 0.03:0.04:0.93
%       j=j+1;
%       Y(j)=excen3;
%       a12 = abs(173.14*A/(sin(i3*pi/180)*sqrt(1-excen3^2*(cos(omega3*pi/180))^2)));
%       fm3=1/(p3/365.24)^2*((173.14*A/sqrt(1-(excen3*cos(omega3*pi/180))^2 ))^3);   %mass function
%       a3=abs(a12*M12/(SpoctiHmotnost(i3,M12,fm3)));
%       a = 180/pi*60*60*asin((a12+a3)/vzdalenostAU);   %uhlova poloosa obehu v arcsec
%       SumaCtvercu = SumaCtvercuLITE4(JDi,SigmaMin,Epo0,JD00,P,T0,A,p3,omega3,excen3,qmt,T04,A4,p4,omega4,excen4) + CelkemAstroSigma(PocetAstrPouzitych,SigmaPosAng,SigmaSepar,HJD,T0,p3,excen3,a,Omega3,omega3,i3,PosAng,Separ);
%       Z(j,i)=SumaCtvercu;
%    end
% end
% 
% figure(14);
% mesh(Xx,Y,Z);
% xlabel('omega');
% % ylabel('Omega');
% zlabel('{(O-C)_{i}}^2');
% title('V819 Her');
% 
% print -depsc V819Her_3db.eps;

figure(10);
subplot(3,1,1);
hold on
set(gca,'box','on');
ylabel('Total');
plot(SumaProGraf,'.');
hold off 

subplot(3,1,2);
hold on
set(gca,'box','on');
ylabel('LITE');
plot(SumaProGrafLITE,'.');
hold off 

subplot(3,1,3);
hold on
set(gca,'box','on');
ylabel('Astrom.');
plot(SumaProGrafAstrom,'.');
% print -depsc KlesaniRMS.eps;
hold off
