clear;    %clear all variables in memory

%----------------INPUT PARAMETERS: ----------------------
fid = fopen('ParametersAstro.txt','r');  %input file  *.in  with the initial LITE parameters, only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i == 1
        BBB = strread(row, '%c', 'delimiter', ',');
%         Star = cellstr([BBB(1) BBB(2) BBB(3) BBB(4) BBB(5) BBB(6) BBB(7) BBB(8) BBB(9) BBB(10)]); 
        Star = cellstr(BBB);
        Star = Star';
    else
       if row ~= -1
         A=sscanf(row,'%f');
         Y(i-1)=A(1);
     end
    end
end
status = fclose('all');      %close the file
clear A row i fid status BBB;    %it is better to clear all unnecessary variables from the memory
Y=Y';
%------------------------------------------------------------

%---------------INPUT DATA POINTS (=astrometric measurements): ---------------------
fid = fopen('Astrometry.txt','r');  %input file  *.dat, open only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i ~= 1
       if row ~= -1
         A=sscanf(row,'%f');
         YearAstr(i-1)=A(1);
         Separ(i-1)=A(2);
         PosAng(i-1)=A(3);
         Wght(i-1)=A(4);
     end
    end
end
status = fclose('all');
clear A row fid status;
PocetAstr=i-2;   %pocet astrometrickych mereni 
%----------------------------------------------------------------

p3=Y(1);
T0=Y(2);
excen3=Y(3);
a=Y(4);
i3=Y(5);
Omega3=Y(6);
omega3=Y(7);

clear Y;

%-=-=-=-=- zde vykresleni krivky na obloze jeste pred vypoctem -=-=-=-=-=-
alpha=PosAng;
r=Separ;
year=YearAstr;
vaha=Wght;
j=0;
pocetvyrazenych=0;
clear PosAng Separ YearAstr Wght;

for i=1:PocetAstr
    if vaha(i)~= 0     %zde vyradime body co maji vahu = 0
        j=j+1;
        PosAng(j)=alpha(i);
        Separ(j)=r(i);
        YearAstr(j)=year(i);
        Wght(j)=vaha(i);
    elseif vaha(i) == 0
        pocetvyrazenych=pocetvyrazenych+1;
        PosAngVyraz(pocetvyrazenych)=alpha(i);
        SeparVyraz(pocetvyrazenych)=r(i);
        YearAstrVyraz(pocetvyrazenych)=year(i);
        WghtVyraz(pocetvyrazenych)=vaha(i);
    end
end
PocetAstrPouzitych=j;    %pocet opravdove pouzitych, s vahou > 0
clear r alpha year vaha;

xBody=(-1)*Separ.*sin(PosAng*pi/180);   %zde jsou souradnice bodu mereni
yBody=Separ.*cos(PosAng*pi/180);

if pocetvyrazenych > 0
    xBodyVyraz=(-1)*SeparVyraz.*sin(PosAngVyraz*pi/180);
    yBodyVyraz=SeparVyraz.*cos(PosAngVyraz*pi/180);
    for i = 1: pocetvyrazenych
        HJDVyraz(i)=YearToJul(YearAstrVyraz(i));
    end
    j=0;
    for i = 1:pocetvyrazenych     %zde jen teoreticke body na krivce pohybu
        j=j+1;
        HodnotaVyraz = FcniHodnotaAstrometr(HJDVyraz(i),T0,p3,excen3,a,Omega3,omega3,i3);
        xOdBoduVyraz(j) = HodnotaVyraz(1);     %zde souradnice bodu krivky
        yOdBoduVyraz(j) = HodnotaVyraz(2);
        clear HodnotaVyraz;
    end
end

clear SeparVyraz PosAngVyraz;

for i = 1: PocetAstrPouzitych
    HJD(i)=YearToJul(YearAstr(i));
end

j=0;
for HJDKrivky = YearToJul(YearAstr(1)):(p3/1500):(YearToJul(YearAstr(1))+p3)     %pro vykresleni krivky pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJDKrivky,T0,p3,excen3,a,Omega3,omega3,i3);
    xKrivka(j) = Hodnota(1);     %zde souradnice bodu krivky
    yKrivka(j) = Hodnota(2);
    clear Hodnota;
end
clear HJDKrivky;
 
j=0;
for i = 1:PocetAstrPouzitych     %zde jen teoreticke body na krivce pohybu
    j=j+1;
    Hodnota = FcniHodnotaAstrometr(HJD(i),T0,p3,excen3,a,Omega3,omega3,i3);
    xOdBodu(j) = Hodnota(1);     %zde souradnice bodu krivky
    yOdBodu(j) = Hodnota(2);
    RezidRo(j) = Separ(j) - sqrt(xOdBodu(j)^2+yOdBodu(j)^2);
    MeanAnomal(j) = 2*pi*(HJD(j) - T0)/p3;
    EccAnom(j) = kepler(excen3,MeanAnomal(j));
    ny(j) = 2*atan(sqrt((1+excen3)/(1-excen3))*tan(EccAnom(j)/2));   %conversion of anomalies
    r(j) = a*(1-excen3^2)/(1+excen3*cos(ny(j)));
    alfa(j) = Omega3*pi/180+atan(tan(ny(j)+omega3*pi/180)*cos(i3*pi/180));
    ro(j) = r(j)*cos(ny(j)+omega3*pi/180)/cos(alfa(j)-Omega3*pi/180);
    RezidTheta(j) = PosAng(j) - alfa(j)*180/pi;
    clear Hodnota;
end
clear MeanAnomal EccAnom ny r alfa ro;

%--zde zobrazeni zdali jsou vsechny body RezidTheta ve spravnem kvadrantu - tedy v rozezi cca 10 deg, nikoli 180 deg!----
for i = 1:PocetAstrPouzitych
    Sep=1;
end
iks=(-1)*Sep.*sin(RezidTheta*pi/180);
ypsil=Sep.*cos(RezidTheta*pi/180);
figure(1);
hold on
plot(iks,ypsil,'.','MarkerSize',6);
set(gca,'PlotBoxAspectRatio',[1 1 1]);
axis([-1 1 -1 1]);
hold off
%---------
clear iks ypsil;

for i = 1:PocetAstrPouzitych
    if RezidTheta(i) > 90
        if RezidTheta(i) > 270
            RezidTheta(i) = RezidTheta(i) - 360;
        else
            RezidTheta(i) = RezidTheta(i) - 180;
        end
    end
    if RezidTheta(i) < -90
        if RezidTheta(i) < -270
            RezidTheta(i) = RezidTheta(i) + 360;
        else
            RezidTheta(i) = RezidTheta(i) + 180;
        end
    end 
end

%--zde zobrazeni zdali jsou vsechny body RezidTheta ve spravnem kvadrantu - ted by jiz mely byt----
iks=(-1)*Sep.*sin(RezidTheta*pi/180);
ypsil=Sep.*cos(RezidTheta*pi/180);
figure(2);
hold on
plot(iks,ypsil,'.','MarkerSize',6);
set(gca,'PlotBoxAspectRatio',[1 1 1]);
axis([-1 1 -1 1]);
hold off
%---------
clear iks ypsil Sep;

%-----------  figure 1  = before computation  ------------------>
figure(3);
clf
plot(xBody,yBody,'.','MarkerSize',12);    %namerene body
hold on
if pocetvyrazenych > 0
    plot(xBodyVyraz,yBodyVyraz,'o','MarkerSize',3);    %namerene body
    plot(xOdBoduVyraz,yOdBoduVyraz,'r.','MarkerSize',6);  %body na teoreticke krivce
    for i = 1:pocetvyrazenych
        X=[xOdBoduVyraz(i),xBodyVyraz(i)];
        Y=[yOdBoduVyraz(i),yBodyVyraz(i)];
        line(X,Y);
        RezidVyraz(i)=sqrt((xOdBoduVyraz(i)-xBodyVyraz(i))^2+(yOdBoduVyraz(i)-yBodyVyraz(i))^2);
        YearRezidVyraz(i)=YearAstrVyraz(i);
        clear X Y;
    end
end
plot(0,0,'kx','MarkerSize',12);          %stred obehu
plot(xOdBodu,yOdBodu,'r.','MarkerSize',7);  %body na teoreticke krivce
plot(xKrivka,yKrivka,'k.','MarkerSize',1);  % krivka samotna
for i = 1:PocetAstrPouzitych
    X=[xOdBodu(i),xBody(i)];
    Y=[yOdBodu(i),yBody(i)];
    line(X,Y);
    Rezid(i)=sqrt((xOdBodu(i)-xBody(i))^2+(yOdBodu(i)-yBody(i))^2);
    YearRezid(i)=YearAstr(i);
    clear X Y;
end
xlabel('RA[arcsec]');
ylabel('DE[arcsec]');
% axis([-0.15 0.15 -0.15 0.15]);
set(gca,'PlotBoxAspectRatio',[1 1 1]);
hold off
clear xKrivka yKrivka xOdBodu yOdBodu xBody yBody xBodyVyraz yBodyVyraz xOdBoduVyraz yOdBoduVyraz;
%------------------------------------------------------------------- 
% figure(2);
% clf
% hold on
% plot(YearRezid,Rezid,'k.','MarkerSize',15);
% if pocetvyrazenych > 0
%     plot(YearRezidVyraz,RezidVyraz,'ko','MarkerSize',2);
% end
% set(gca,'box','on');
% title('Po odecteni astrometrie'); 
% % print -deps V819Her-rezidua.eps;
% hold off

Output=[YearRezid; PosAng; RezidTheta; Separ; RezidRo];

BB=char(Star);
%-------------- O U T P U T --------------->>>
fid = fopen('Astrometry_2.txt','w');
fprintf(fid,'%s\n',BB');
fprintf(fid,'%11.5f    %5.5f    %4.10f     %5.4f    %2.9f\n',Output);
status=fclose('all');

clear Separ PosAng;
