%Simplex Program for computing 7 elements of the Light-Time Effect of concrete system !!!
clear;    %clear all variables in memory

%----------------INPUT PARAMETERS: ----------------------
fid = fopen('Parameters.txt','r');  %input file  *.in  with the initial LITE parameters, only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i == 1
        BBB = strread(row, '%c', 'delimiter', ',');
%         Star = cellstr([BBB(1) BBB(2) BBB(3) BBB(4) BBB(5) BBB(6) BBB(7) BBB(8) BBB(9) BBB(10)]); 
        Star = cellstr(BBB);
        Star = Star';
    else
       if row ~= -1
         A=sscanf(row,'%f');
         Y(i-1)=A(1);
       end
    end
end
status = fclose('all');      %close the file
clear A row i fid status BBB;    %it is better to clear all unnecessary variables from the memory
Y=Y';
%------------------------------------------------------------

%---------------INPUT DATA POINTS (=minima times): ---------------------
fid2 = fopen('Minima.txt','r');  %input file  *.min  with the data (times of minima - JDi), open only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid2);
    if i ~= 1
       if row ~= -1
         A=sscanf(row,'%f');
         Minima(i-1)=A(1);
         Weight(i-1)=A(2);
     end
    end
end
status = fclose('all');
clear A row fid2 status;
%----------------------------------------------------------------

N=i-2;      %number of data points (minima times)

Minima=Minima';     %minima times
Weight=Weight';      %weights of individual minima times
JDi=Minima+2400000;   %Juliane date of individual minima times

JD00=Y(1);    %here are the 8 parameters of the LITE from the Y matrix
P=Y(2);

clear Y i Minima;

Epo=Epoch(JDi,JD00,P);    %Epoch of individual minima times

Output=[JDi'; Weight'; Epo'];
BB=char(Star);

%-------------- O U T P U T --------------->>>
fid = fopen('Epoch_times.txt','w');
fprintf(fid,'%s\n',BB');
fprintf(fid,'%12.6f   %2.0f   %8.2f\n',Output);
status=fclose('all');
