clear;    %clear all variables in memory

%----------------INPUT PARAMETERS: ----------------------
fid = fopen('Parameters.txt','r');  %input file  *.in  with the initial LITE parameters, only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i == 1
        BBB = strread(row, '%c', 'delimiter', ',');
%         Star = cellstr([BBB(1) BBB(2) BBB(3) BBB(4) BBB(5) BBB(6) BBB(7) BBB(8) BBB(9) BBB(10)]); 
        Star = cellstr(BBB);
        Star = Star';
    else
       if row ~= -1
         A=sscanf(row,'%f');
         Y(i-1)=A(1);
       end
    end
end
status = fclose('all');      %close the file
clear A row i fid status BBB;    %it is better to clear all unnecessary variables from the memory
Y=Y';
%------------------------------------------------------------

%---------------INPUT DATA POINTS (=minima times): ---------------------
fid2 = fopen('Epoch_times.txt','r');  %input file  *.min  with the data (times of minima - JDi), open only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid2);
    if i ~= 1
       if row ~= -1
         A=sscanf(row,'%f');
         JDi(i-1)=A(1);     %Juliane date of individual minima times
         Weight(i-1)=A(2);   %Weights of individual minima times
         Epo0(i-1)=A(3);    %Epochs of individual minimum times
     end
    end
end
status = fclose('all');
clear A row fid2 status;
%----------------------------------------------------------------
N=i-2;      %number of data points (minima times)

JDi=JDi';   %Minima times
Weight=Weight';   %Weights of individual minima times
Epo0=Epo0';        %Epoch of individual minima times

JD00=Y(1);    %here are 10 parameters of the LITE + Astrometry from the Y matrix
P=Y(2);
p3=Y(3);
T0=Y(4);
A=Y(5);
omega3=Y(6);
excen3=Y(7);
qmt=Y(8);

clear Y;

%-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
%Epo0=Epoch(JDi,JD00,P);    %Epoch of individual minima times
O=JDi-JD00-P*Epo0;         %O-C difference

PocetPrim=0;
PocetSec=0;
for i = 1:N
   switch round(10*abs(Epo0(i)-round(Epo0(i))))
   case 0
       PocetPrim=PocetPrim+1;
       E11(PocetPrim)=Epo0(i);    %primary minima times
       Occ1(PocetPrim)=O(i);
       B1(PocetPrim)=Weight(i);
   case 5            %secondary minima times
       PocetSec=PocetSec+1;
       E21(PocetSec)=Epo0(i);
       Occ2(PocetSec)=O(i);   
       B2(PocetSec)=Weight(i);
   end
end

m=1;
n=1;
o=1;
o1=1;
remove=0;       %some minima times were eliminated
for i = 1:PocetPrim     %primary minima times
   switch B1(i)
   case 0          %weight = 0  =>  ignore this minimum!
      remove=remove+1;     %removed minima times (=weight 0)
   case 1        %visual primary minima times
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 2        %visual primary minima times
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 3        %visual primary minima times
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 4        %visual primary minima times
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 5       %photographic primary minima times, worse quality
      E1pp(o1)=E11(i);
      O1pp(o1)=Occ1(i);
      o1=o1+1;
   case 10        %photographic primary minima times
      E1p(o)=E11(i);
      O1p(o)=Occ1(i);
      o=o+1;
   case 30       %ccd primary minima times
      E1c(m)=E11(i);
      O1c(m)=Occ1(i);
      m=m+1;
   end
end

p=1;
q=1;
r=1;
o2=1;
for i = 1:PocetSec     %secondary minima times
   switch B2(i)
   case 0
      remove=remove+1;   %removed secondary minima times
   case 1         %visual secondary minima times
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 2         %visual secondary minima times
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 3         %visual secondary minima times
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 4         %visual secondary minima times
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 5       %photographic secondary minima times, worse quality
      E2pp(o2)=E21(i);
      O2pp(o2)=Occ2(i);
      o2=o2+1;
   case 10         %photographic secondary minima times
      E2p(q)=E21(i);
      O2p(q)=Occ2(i);
      q=q+1;
   case 30        %ccd secondary minima times
      E2c(r)=E21(i);
      O2c(r)=Occ2(i);
      r=r+1;
   end
end

minimumE=1000*floor(min(Epo0)/1000)-1000;
maximumE=1000*ceil(max(Epo0)/1000)+2000;

Ep=minimumE:(maximumE-minimumE)/200:maximumE;       %plot a curve
JDi0=Ep*P+JD00;
Oc=OminusC(JDi0,T0,A,p3,omega3,excen3) + 10^(-10)*qmt*Ep.*Ep;

%--------------- HERE PLOT THE FIGURE: --------------------
figure(4);
clf;
set(gca,'box','on');
hold on
if n > 1 plot(E1v,O1v,'k.','MarkerSize',6); end    %plot primary visual minima times
if o1 > 1 plot(E1pp,O1pp,'k.','MarkerSize',8); end  %primary photographic minima times, worse quality
if o > 1 plot(E1p,O1p,'k.','MarkerSize',12); end   %primary photographic minima times
if m > 1 plot(E1c,O1c,'k.','MarkerSize',17); end   %primary ccd minima times
if p > 1 plot(E2v,O2v,'ko','MarkerSize',2); end    %secondary visual minima times
if o2 > 1 plot(E2pp,O2pp,'ko','MarkerSize',2); end  %secondary photographic minima times, worse quality
if q > 1 plot(E2p,O2p,'ko','MarkerSize',3); end    %secondary photographic minima times
if r > 1 plot(E2c,O2c,'ko','MarkerSize',4); end    %secondary ccd minima times
plot(Ep,Oc,'r-');
xlabel('Epoch');   %labeling the axis
ylabel('O-C (Days)');
title('O-C diagram');   %labeling the figure
hold off
%--------------------------------------------------------------------------
clear E1c E1v E1p E2c E2v E2p E1pp E2pp O1pp O2pp O1v O1c O1p O2v O2c O2p j k m n o o1 p q r o2 B1 B2 Occ1 Occ2 E11 E21 O Oc Ep JDi0 minimumE maximumE;   %clear all unnecessary variables
%---------------------------------------------------------------------------------------------------------

O=JDi-JD00-P*Epo0-(OminusC(JDi,T0,A,p3,omega3,excen3))-10^(-10)*qmt*Epo0.*Epo0;

clear Output;
% Output=[JDi'; O'; Epo0'; Weight'];

j=0;
for i = 1:length(JDi)
    if Weight(i) ~= 0
        j=j+1;
        JDiMin(j)=JDi(i);
        OMin(j)=O(i);
        Epo0Min(j)=Epo0(i);
        WeightMin(j)=Weight(i);
    end
end
% OMin=OMin./WeightMin;  %jina moznost, jeste zapocist vahovani dle puvodnich vah, vzdelit sigma -> zvetsi se vaha LITE celkove!
OutputMin=[JDiMin; OMin; Epo0Min; WeightMin];

figure(5);
hold on
plot(JDiMin,OMin,'k.','MarkerSize',6);
hold off

BB=char(Star);
%-------------- O U T P U T --------------->>>
fid = fopen('Epoch_times_2.txt','w');
fprintf(fid,'%s\n',BB');
fprintf(fid,'%12.6f    %5.8f    %8.3f    %6.2f\n',OutputMin);
status=fclose('all');
