function [Result] = FcniHodnotaAstrometr2(Year,t0,p3,e,a,OmegaX,omegaXX,i3) %funkce na vypocteni polohy na obloze (x,y)=(RA,DE) z daneho roku a parametru orbity 3.telesa
    %vstup: Year[yr], t0[yr], p3[yr], e, a[arcsec], OmegaX[deg], omegaXX[deg], i3[deg]
    
    Omeg=OmegaX*pi/180;
    om=omegaXX*pi/180;
    
    MeanAnomal = 2*pi*(Year - t0)/p3;
    EccAnom = kepler(e,MeanAnomal);
    ny = 2*atan(sqrt((1+e)/(1-e))*tan(EccAnom/2));   %conversion of anomalies
    r = a*(1-e^2)/(1+e*cos(ny));
    alfa = Omeg+atan(tan(ny+om)*cos(i3*pi/180));  % male theta
    ro = r*cos(ny+om)/cos(alfa-Omeg);
    
    A=a*(   cos(om)*cos(Omeg) - sin(om)*sin(Omeg)*cos(i3*pi/180));
    B=a*(   cos(om)*sin(Omeg) + sin(om)*cos(Omeg)*cos(i3*pi/180));
    F=a*(-1*sin(om)*cos(Omeg) - cos(om)*sin(Omeg)*cos(i3*pi/180));
    G=a*(-1*sin(om)*sin(Omeg) + cos(om)*cos(Omeg)*cos(i3*pi/180));
    
    X=cos(EccAnom)-e;          %zde souradnice bodu krivky
    Y=sqrt(1-e^2) * sin(EccAnom);
    
    x=A*X+F*Y;
    y=B*X+G*Y;
    
%     x = (-1)*ro*sin(alfa);     %zde souradnice bodu krivky - spatne!
%     y = ro*cos(alfa);
    clear MeanAnomal EccAnom ny r alfa ro A B F G Omeg om;

Result(1) = x;   %result x (RA)
Result(2) = y;   %result y (DE)
