function [Result] = OminusC(JDi,T0,A,p3,omega,excen)  %function to compute (O-C) from JDi, T0, A, p3, omega and excen

    Ex=kepler(excen,2*pi/p3*(JDi-T0));   %eccentric anomaly from Kepler equation
    ny=2*atan(sqrt((1+excen)/(1-excen))*tan(Ex/2));   %conversion of anomalies
    Oc=((1-excen^2)./(1+excen.*cos(ny)).*sin(ny+omega*pi/180)+excen.*sin(omega*pi/180))/sqrt(1-excen^2*((cos(omega*pi/180))^2));    %basic equation to compute Light-Time effect
    
Result=A*Oc;    %eccentric anomaly
