function [Result] = RMSAstrometrSigma(Year,t0,p3,e,a,Omega,omega,i3,PosAng,Separ,SigmaPosAng,SigmaSepar) %funkce na vypocteni polohy na obloze (x,y)=(RA,DE) z daneho roku a parametru orbity 3.telesa
    %vstup: Year[yr], t0[yr], p3[yr], e, a[arcsec], Omega[deg], omega[deg], i3[deg], PosAng(arcs),Separ(arcs),SigmaPosAng(deg),SigmaSepar(arcs)
    
    MeanAnomal = 2*pi*(Year - t0)/p3;
    EccAnom = kepler(e,MeanAnomal);
    ny = 2*atan(sqrt((1+e)/(1-e))*tan(EccAnom/2));   %conversion of anomalies
    r = a*(1-e^2)/(1+e*cos(ny));
    alfa = Omega*pi/180+atan(tan(ny+omega*pi/180)*cos(i3*pi/180)); %rad!
    ro = r*cos(ny+omega*pi/180)/cos(alfa-Omega*pi/180);
    x = (-1)*ro*sin(alfa);     %zde souradnice bodu krivky
    y = ro*cos(alfa);
    if x >= 0 & y > 0
        alfa = 2*pi - atan(abs(x)/abs(y));
    end
    if x < 0 & y > 0
        alfa = atan(abs(x)/abs(y));
    end
    if x <= 0 & y < 0 
        alfa = pi - atan(abs(x)/abs(y));
    end
    if x > 0 & y < 0
        alfa = pi + atan(abs(x)/abs(y));
    end
    if y == 0 & x < 0
        alfa = pi/2;
    end
    if y == 0 & x > 0
        alfa = pi * 3/2;
    end
%     if (sin(alfa) > 0 & cos(alfa) > 0) & ro < 0
%         alfa = alfa + pi;
%     end
%     if (sin(alfa) < 0 & cos(alfa) > 0) & ro > 0
%         alfa = alfa + 2*pi;
%     end
%     if (sin(alfa) < 0 & cos(alfa) > 0) & ro < 0
%         alfa = alfa + pi;
%     end
% %     if sin(alfa) < 0 & cos(alfa) < 0
% %         alfa=alfa+pi;
% %     elseif sin(alfa) < 0 & cos(alfa) > 0
% %         alfa=alfa+pi;
% %     end        
    Xx = ((abs(ro)-abs(Separ))/abs(SigmaSepar))^2 + ((alfa-(PosAng*pi/180))/(SigmaPosAng*pi/180))^2;  %suma ctvercu od 1 mereni, od uhloveho (theta) i radialniho (ro)
    clear MeanAnomal EccAnom ny r alfa ro x y;

Result = Xx;

